import api
import appModuleHandler
import tones
import ui
import winUser
import mouseHandler
import scriptHandler
from scriptHandler import getLastScriptRepeatCount, script
from logHandler import log
from . import UIAFinder
import UIAHandler
import editableText

class AppModule(appModuleHandler.AppModule):
	scriptCategory = "messenger"
	def event_gainFocus(self, obj, nextHandler):
		
		#tones.beep(123,123)
		if obj.UIAAutomationId.startswith("chat-cell"):
			obj.name=' ,'.join([i.name for i in obj.children])
		if obj.name==''   and obj.childCount>0 :
			
			
			obj.name=readMessagesFromObject(obj)
			obj.role=15
		nextHandler()
	

	@script(
	gesture="kb:home",
	description=_("listStart"))
	def script_listStart(self, gesture):
		if api.getFocusObject().parent.UIAElement.CachedClassName=='ScrollViewer':
			api.getFocusObject().parent.firstChild.setFocus()
		else: api.getFocusObject().script_caret_moveByCharacter(gesture)

	@script(
	gesture="kb:end",
	description=_("listend"))
	def script_listEnd(self, gesture):
		if api.getFocusObject().parent.UIAElement.CachedClassName=='ScrollViewer':
			api.getFocusObject().parent.lastChild.setFocus()
		else: api.getFocusObject().script_caret_moveByCharacter(gesture)



		
	@script(
	gesture="kb:applications",
	description=_("right click messenger"))
	def script_rigtClick(self, gesture):
		focus=api.getFocusObject()
		setMousePosition(focus.location.center.x, focus.location.center.y, True)
			
	@script(
	gesture="kb:alt+2",
	description=_("focus message list"),
	)
	def script_messageList(self, gesture):
		list=UIAFinder.getObject(api.getForegroundObject(), name="Messages List")
		list.setFocus()

	@script(
	gesture="kb:alt+1",
	description=_("focus chat  list"),
	)
	def script_chatList(self, gesture):
		list=UIAFinder.getObject(api.getForegroundObject(), id="chat-cell-0")
		list.setFocus()
		
	@script(
	gesture="kb:alt+3",
	description=_("focus editor"),
)
	def script_editor(self, gesture):
		edit=UIAFinder.getObject(api.getForegroundObject(), id="composer_editor")
		edit.setFocus()

	@script(
	gesture="kb:alt+d",
	description=_("toggle between messages and edit box"),
	)
	def script_MessageEditToggle(self, gesture):
		focus=api.getFocusObject()
		if focus.role==15:
			self.script_editor(gesture)
		else:
			self.script_messageList( gesture)
			
	@script(
	gesture="kb:alt+a",
	description=_("read user status"),
	)
	def script_status(self, gesture):
		audio_call_button=UIAFinder.getObject(api.getForegroundObject(), id="audio_call_button")
		status=UIAHandler.handler.baseTreeWalker.GetPreviousSiblingElementBuildCache(audio_call_button,UIAHandler.handler.baseCacheRequest)
		ui.message(status.CurrentName)
		
		
		
def setMousePosition(x, y,  click):
	
	winUser.setCursorPos(x, y)
	mouseHandler.executeMouseMoveEvent(x, y)
	if click:
		winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTDOWN, 0, 0, None, None)
		winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTUP, 0, 0, None, None)

	
def readMessagesFromObject(obj):
	messages=''
	for i in range (0, obj.childCount):
		current=obj.getChild(i)
		#log.info(current.devInfo)
		#log.info(current.childCount)
		if current.role==9 and current.childCount>0: #message
			if current.getChild(0).role==0 or 0:
				messages+=current.getChild(1).name+". "
			else:
				try:
					messages+=current.getChild(0).name+" , "
				except: pass
		elif current.role==7: #user
			messages+=current.name+": "
		elif current.role==56: #status
			messages+=current.name+". "
	return messages